Imports System
Imports System.Runtime.InteropServices
Imports System.EnterpriseServices
Imports System.Reflection

' Supply the COM+ application name. 
<Assembly: ApplicationName("BankComponent")> 

' Supply a strong-named assembly.
<Assembly: AssemblyKeyFileAttribute("c:\btsdotnet\bankvb\Bankvb.snk")> 

<Assembly: ComVisible(True)> 

'The following GUID is for the ID of the typelib if this project is exposed to COM
<Assembly: Guid("77AA902A-5D30-42CB-83DB-2A26B4081228")> 

Namespace BankVB
    <Transaction(TransactionOption.Required), _
    ComClass("73297D71-DA59-43b6-9511-9743B379BF02")> _
    Public Class UpdateBankVB : Inherits ServicedComponent
        ' Define a local variable to store the DSN value.

        <AutoComplete()> _
        Public Function Credit(ByVal AccountNo As Integer, ByVal AmountToCredit As Integer, ByVal myBank As String) As Boolean
            Dim myConn As New ADODB.Connection()
            Dim myCommand As New ADODB.Command()
            Dim myConnectionString As String

            myConnectionString = "Provider=SQLOLEDB.1;Persist Security Info=False;User ID=sa;Initial Catalog=" & myBank & ";Data Source=localhost"

            Try
                myConn.Open(myConnectionString)

                myCommand.ActiveConnection = myConn
                myCommand.CommandType = ADODB.CommandTypeEnum.adCmdStoredProc
                myCommand.CommandText = "Credit"
                myCommand.Parameters.Refresh()
                myCommand.Parameters("@AccountNo").Value = AccountNo
                myCommand.Parameters("@AmountToCredit").Value = AmountToCredit

                myCommand.Execute()

                Credit = CBool(myCommand.Parameters("@AccountBalance").Value)
                Credit = True

            Catch ex As Exception
                MsgBox("Error: " & ex.ToString())
                Credit = False
                'Throw New Exception("Database Error")
            Finally
                myConn.Close()
                myCommand = Nothing
                myConn = Nothing
            End Try
        End Function

        <AutoComplete()> _
        Public Function Debit(ByVal AccountNo As Integer, ByVal AmountToDebit As Integer, ByVal myBank As String) As Boolean
            Dim myConn As New ADODB.Connection()
            Dim myCommand As New ADODB.Command()
            Dim myConnectionString As String

            myConnectionString = "Provider=SQLOLEDB.1;Persist Security Info=False;User ID=sa;Initial Catalog=" & myBank & ";Data Source=localhost"

            Try
                myConn.Open(myConnectionString)
                myCommand.ActiveConnection = myConn
                myCommand.CommandType = ADODB.CommandTypeEnum.adCmdStoredProc
                myCommand.CommandText = "Debit"

                myCommand.Parameters.Refresh()
                myCommand.Parameters("@AccountNo").Value = AccountNo
                myCommand.Parameters("@AmountToDebit").Value = AmountToDebit

                myCommand.Execute()

                Debit = CBool(myCommand.Parameters("@AccountBalance").Value)
                Debit = True
            Catch ex As Exception
                MsgBox("Error: " & ex.ToString())
                Debit = False
                'Throw New Exception("Database Error")
            Finally
                myConn.Close()
                myCommand = Nothing
                myConn = Nothing
            End Try
        End Function

    End Class

    <ComClass("D995F48F-C075-426b-8D49-6B4E17CFF3F5")> _
    Public Class QueryBankVB
        Public Function DisplayBalances(ByVal Bank1Account As Integer, ByVal Bank1 As String, ByVal Bank2Account As Integer, ByVal Bank2 As String) As String
            Dim iBank1 As Integer
            Dim iBank2 As Integer

            iBank1 = GetBalance(1, Bank1)
            iBank2 = GetBalance(1, Bank2)
            DisplayBalances = Bank1 & ": " & CStr(iBank1) & "    " & Bank2 & ": " & CStr(iBank2)
            DisplayMsg(DisplayBalances)
        End Function

        Public Function DisplayMsg(ByVal sMessage As String)
            MsgBox(sMessage)
        End Function

        Public Function GetBalance(ByVal AccountNo As Integer, ByVal myBank As String) As String

            Dim myConn As New ADODB.Connection()
            Dim myCommand As New ADODB.Command()
            Dim myConnectionString As String

            Try
                myConnectionString = "Provider=SQLOLEDB.1;Persist Security Info=False;User ID=sa;Initial Catalog=" & myBank & ";Data Source=localhost"

                myConn.Open(myConnectionString)

                myCommand.ActiveConnection = myConn
                myCommand.CommandType = ADODB.CommandTypeEnum.adCmdStoredProc
                myCommand.CommandText = "AccountBalance"

                myCommand.Parameters.Refresh()
                myCommand.Parameters("@AccountNo").Value = AccountNo

                myCommand.Execute()

                GetBalance = myCommand.Parameters("@AccountBalance").Value
            Catch ex As Exception
                MsgBox("Error: " & ex.ToString())
            Finally
                myCommand = Nothing
                myConn.Close()
                myConn = Nothing
            End Try
        End Function
    End Class
End Namespace

